﻿:Class ServerSideFormValidation : MildPage

    :Include #.HTMLInput              ⍝ Useful functions for creating HTML pages

    :Field Public Name←''             ⍝ Name of edit field
    :Field Public Action←''           ⍝ All action buttons have this name
    :Field Private Tries←0            ⍝ Number of attempts to fill the Name field
    :Field Private Page←1             ⍝ Page visible to user
    

    ∇ Render req;html
      :Access Public
      DoAction                        ⍝ If a button was pressed, deal with it

      html←BRA'h2'Enclose'Server Side Validation' ⍝ display a headline
      :If 1=Page                        ⍝ Display page 1
          html,←BRA 'h3' Enclose EnterName
          html,←'Name'Edit Name           ⍝ An "Edit" called "Name" containing the Name
          html,←'<br/><br/>'
          html,←'Action'Submit'Submit Name'   ⍝ A button named 'Action' with Caption 'Submit'
      :Else                             ⍝ Display page 2
          html,←2 BRA  'h3' Enclose 'Nice to meet you, ',Name,'.'
          html,←'Action'Submit'Reset'     ⍝ ... another button named 'Action'
      :EndIf
      html←req('post'Form)html        ⍝ Put a 'submit' form around it
     
      req.Return html
    ∇

    ∇ DoAction;_
      :Select Action
      :Case 'Submit Name'
          :If 0=⍴Name ⍝ If nothing is in the Name field, add one to Tries
              Tries←Tries+1
          :Else  ⍝ If something is in the Name field, move to the next page and reset the Tries counter.
              Tries←0
              Page←2
          :EndIf
      :Case 'Reset' ⍝ Reset the example
          Name←''
          Tries←0
          Page←1
      :EndSelect
      :Select Tries ⍝ Change the input request based in the Tries field
      :Case 0
          EnterName←'Enter Your Name:'
      :Case 1
          EnterName←'Please Enter Your Name:'
      :Case 2
          EnterName←'Seriously, just type your name below:'
      :Case 3
          EnterName←'Now you''re just doing this to bother me. Just enter your name.'
      :Case 4
          EnterName←'I GIVE UP!'
          Name←'MiServer'
      :EndSelect
     
    ∇

:EndClass