﻿:Class UserControl : MildPage

    ⎕IO ⎕ML←1 1

    :Include #.HTMLInput              ⍝ Useful functions for creating HTML pages

    :Field Private FileName←'config/users.xml'         ⍝ Name of page to edit
    :Field Private Message←''        
    :Field Public Action←''           ⍝ All action buttons have this name
    :Field Public row←''              ⍝ row to act upon
    :Field Private UserTable←''
    :Field Private html
    
    get←{(⍺[;1]⍳⊂⍵)⊃⍺[;2],⊂''}
    toNum←{w←⍵ ⋄ (('-'=w)/w)←'¯' ⋄ ⊃//⎕vfi w}
    crlf←⎕UCS 13 10

    ∇ Render req;html;⎕TRAP;script
      :Access Public
      ⎕TRAP←0 'S'
     
      DoAction req                       ⍝ If a button was pressed, deal with it
     
      html←'h1'Enclose'User Control'
      html,←(~0∊⍴Message)/Message,'<br>'
      html,←∊'Action'∘Submit¨'Add User' 'Reset'
      html,←UserTable
      html,←'row'Hidden''
      html←req('post'Form)html        ⍝ Put a 'submit' form around it
      script←'function clicker(who,row,action){',crlf
      script,←'document.forms[0].row.value=row;',crlf
      script,←'if (action=="Delete"){',crlf
      script,←'return (confirm("Delete " + who + "?"));}',crlf
      script,←'else{return true;}}'
      html,←JS script
      req.Title'User Control'
      req.Return html
    ∇

    ∇ html←DoAction req;users;data;dels;eds;submit
      :Select Action
      :Case 'Delete'
          Message←'Deleting row: ',row
          req.Session.State.Users.Users←req.Session.State.Users.Users{m←(⍴⍺)⍴1 ⋄ m[⍵]←0 ⋄ m/⍺} toNum row
      :Case 'Edit'
          Message←'Editing row: ',row
      :CaseList '' 'Reset'
        req.Session.State.Users←#.XML.ToNS ⎕SE.UnicodeFile.ReadText req.Server.Root,{((1↑⍵)∊'/\')↓⍵}FileName 
      :Case 'Add User'
      :Case 'Save' 
      :Case 'Save User'
      :Else
 ...       
      :EndSelect

      users←req.Session.State.Users
      :if 0∊⍴users.Users
        data←0 3⍴⊂''
      :else
        data←↑users.Users.(ID Pass Groups)
      :endif
      submit←{('<input type="Submit" name="Action" value="',⍺,'" onClick="return clicker(''')∘,¨⍵[;1],¨(''','∘,¨⍕¨⍳⊃⍴⍵),¨⊂',''',⍺,''');"/>',crlf}
      dels←'Delete'submit data
      eds←'Edit'submit data
      UserTable←Table('User' 'Password' 'Groups' 'Edit' 'Delete'⍪(data,eds),dels) 'border="1"' '' 1
    ∇    
    
:EndClass