﻿:Class Dyalog2011 : MildServer

    NL←⎕UCS 13 10

    :Include #.HTMLInput

    ∇ make args;file
      :Access Public
      :Implements Constructor :Base args
      :If #.Files.Exists file←Root,'/config/DataSources.xml'
          Datasources←(#.XML.ToNS #.Files.GetText file).Datasources
          :If 0=#.⎕NC'SQA'
              'SQA'#.⎕CY'SQAPL' ⍝ retrieve SQA if needed
          :EndIf
      :EndIf
    ∇

    ∇ onSessionEnd session;msg
      :Access Public Override
      :With session
          msg←'End of session ',(⍕ID),': User=',User,'; Last active: ',,#.Dates.TSFmtNice LastActive
      :EndWith
      4 Log msg
    ∇

    ∇ onSessionStart req
      :Access Public Override
      4 Log'New session ',(⍕req.Session.ID),' started to process ',req.Page
    ∇

    ∇ level Log msg;report
      :Access Public Override
      report←Config.LogMessageLevel ⍝ report levels specified in config (use 0 for no reporting, ¯1 for all)
      :If report bit level
          ⎕←msg
      :EndIf
    ∇

    ∇ Wrap req;body;head;html;footer;banner;content;lang
    ⍝ "Wraps" the HTML body
    ⍝ This version implements a template to create a standard look and feel for all MildPages served by this site
    ⍝ This is provided as an example for some of the uses of Wrap
     
      :Access Public Override
      head←'title'Enclose req.Server.Config.Name ⍝ Sets the name of the page at the top of the browser to the Name specified in server.xml
      head,←Tag'link href="/Styles/style.css" rel="stylesheet" type="text/css"' ⍝ add the style sheet reference
     
    ⍝↓↓↓ If your code that builds the page updates HTMLHead (content that goes in the <head> element of the HTML document) it gets appended here.
    ⍝    This means that any style changes introduced by your code will override those in the /Styles/style.css for elements defined by both stylesheets
      head,←req.Response.HTMLHead,NL ⍝ Adds additional html head information
      head←'head'Enclose head
     
    ⍝ The design for this template implements a structure for the content within the body of the HMTL file
    ⍝ The <body> element encloses three <div> elements containing: a banner, the content, a footer
      banner←#.Files.GetText req.Server.Root,'\Styles\banner.txt'
      content←'div id="contentblock"' Enclose req.Response.HTML
      footer←#.Files.GetText req.Server.Root,'\Styles\footer.txt'
     
    ⍝↓↓↓ We enclose the banner/content/footer with a "wrapper" div so that the visible content of the page can be sized, aligned, floated, etc.
    ⍝    <body> serves as the background and overall container (not to mention being required!)
      body←'body'Enclose NL,'div id="wrapper"'Enclose banner,NL,content,NL,footer
     
    ⍝↓↓↓ We use XHTML for this site and recommend its use.  See http://www.w3schools.com/html/html_xhtml.asp for a discussion of HTML v. XHTML
      lang←req.Server.Config.Lang ⍝ use the language specified in Server.xml
      html←'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">',NL
      html,←('html lang="',lang,'" xml:lang="',lang,'" xmlns="http://www.w3.org/1999/xhtml"')Enclose head,body
      req.Response.HTML←html
    ∇

      bit←{⎕IO←0  ⍝ used by Log
          0=⍺:0 ⍝ all bits turned off
          ¯1=⍺:1 ⍝ all bits turned on
          (⌈2⍟⍵)⊃⌽((1+⍵)⍴2)⊤⍺}

:EndClass