﻿:Namespace JQ
    ⎕IO ⎕ML ⎕WX←1 0 3
⍝ == JQ - JQuery Utilities
⍝ For more information:
⍝ * JQuery - http://jquery.com
⍝ * JQUery UI - http://jqueryui.com
⍝ * Search on the web for "jquery plugin"

    CRLF←⎕UCS 13 10

⍝ First define the javascript and css files that may be included
⍝ The source for JQuery related files is {MildServerRoot}/PlugIns/JQuery
⍝ We copy the pertinent files to /Scripts and /Styles of the MildSite
⍝ And build references to them below...

    JQuery←'src="/Scripts/jquery.js"'                          ⍝ JQuery javascript
    JQueryUIcss←'/Styles/redmond/jquery-ui.css'                ⍝ JQuery UI styles
    JQueryUI←'src="/Scripts/jquery-ui.js"'                     ⍝ JQuery UI javascript
    JQueryTS←'src="/Scripts/jquery.tablesorter.js"'        ⍝ TableSorter javascript
    JQueryTScss←'/Styles/blue/style.css'                       ⍝ TableSorter styles
    JQueryTSPager←'src="/Scripts/jquery.tablesorter.pager.js"' ⍝ TableSorter Pager javascript
    JQueryDims←'src="/Scripts/jquery.dimensions.js"'           ⍝ JQuery Dimensions plug-in javascript

    ine←{0∊⍴⍺:'' ⋄ ⍵}  ⍝ if not empty
    eis←{2>|≡⍵:,⊂⍵ ⋄ ⍵} ⍝ Enclose if simple
    enlist←{⎕ML←2 ⋄ ∊⍵} ⍝ APL2 style enlist
    firstAfter←{pos str←⍵ ⋄ pos+1⍳⍨⍺⍷pos↓str} ⍝ return position of first occurrence after a position

    ∇ r←class insertClass attrs;m;beg;end;q;f
     ⍝ insert class into a list of attributes, if there's already a class= attribute append class to it
      :If ~∨/m←'class='⍷attrs ⋄ r←'class="',class,'"',(0∊⍴attrs)↓' ',attrs ⋄ :Return ⋄ :EndIf
      q←(6+beg←m⍳1)⊃attrs,' '
      :If q∊'''"' ⋄ end←¯1+q firstAfter(6+beg)attrs ⋄ r←(end↑attrs),' ',class,end↓attrs
      :Else
          f←~(⍴attrs)≥end←¯1+' 'firstAfter(5+beg)attrs
          r←attrs
          r[beg+5]←⊂'="'
          r←enlist((end-f)↑r),(f↓' ',class,'"'),end↓r
      :EndIf
    ∇

    ∇ IncludeJQuery req
    ⍝ include JQuery script link in HTML <head>
      JQuery req.Script''
    ∇

    ∇ IncludeJQueryUI req
    ⍝ include the standard JQuery-UI file links in HTML <head>
      req.Style JQueryUIcss
      IncludeJQuery req
      JQueryUI req.Script''
    ∇

    ∇ r←JQueryfn pars;jqfn;id;jqpars;chain;script
    ⍝ pars - [1] jquery function name, [2] html id, [3] jquery function parameters, [4] jquery function chain
    ⍝ for usage examples, see other functions in this namespace
      pars←eis pars
      jqfn id jqpars chain←pars,(⍴pars)↓'' '' '' ''
      r←#.HTMLInput.JS'$("',(¯2↓enlist'#',¨(eis id),¨⊂', '),'").',jqfn,'(',(jqpars ine'{',jqpars,'}'),')',chain,';'
    ∇

    ∇ r←{req}DatePicker pars;id;editpars;jqpars
    ⍝ req - HTTPRequest object
    ⍝ pars - id editpars jqpars
    ⍝ id - the id for the datepicker
    ⍝ editpars - parameters for the edit field (see HTMLInput.Edit)
    ⍝ jqpars - datepicker parameters
    ⍝ updates req.Response.head and returns html
      :If 9=⎕NC'req' ⋄ IncludeJQueryUI req ⋄ :EndIf
      pars←eis pars
      id editpars jqpars←pars,(⍴pars)↓''⍬''
      r←id #.HTMLInput.Edit editpars
      r,←JQueryfn'datepicker'id jqpars
    ∇

    ∇ r←{req}TableSorter pars;id;tablepars;jqpars;pager;html;sizes;rows;class
    ⍝ req - HTTPRequest object
    ⍝ pars - id tablepars jqpars pager
    ⍝ id - the id for the table to be sorted
    ⍝ jqpars - TableSorter parameters
    ⍝ tablepars - parameters for the table (see HTMLInput.Table)
    ⍝ pager - use the tablesorterPager plug-in?
    ⍝ updates req.Response.head and returns html
     
    ⍝ Usage Notes:
    ⍝ the table is assigned a class of "tablesorter" by this function
    ⍝ the first row is considered a header row
      pars←eis pars
      id tablepars jqpars pager←pars,(⍴pars)↓''⍬'' 0
      :If 9=⎕NC'req'
          JQuery req.Script''
          JQueryTS req.Script''
          req.Style JQueryTScss
      :EndIf
      class←'class="tablesorter"'
      :If 2=⍴⍴tablepars ⋄ tablepars←,⊂tablepars ⋄ :EndIf
      tablepars←tablepars,(⍴,tablepars)↓(1 1⍴⊂'$nbsp;')'' '' '' 1 ⍝ see HTMLInput.Table for
      :If 1∨.≠5⊃tablepars ⋄ 'TableSorter header row must be 1'⎕SIGNAL 11 ⋄ :EndIf
      (2⊃tablepars)←'tablesorter'insertClass 2⊃tablepars
      r←id #.HTMLInput.Table tablepars
      rows←¯1+⍬⍴⍴1⊃tablepars ⍝ rows of table data
      pager∧←10<rows
      :If pager
          JQueryTSPager req.Script''
          JQueryDims req.Script''
          sizes←rows{(⍺+.≥⍵)↑⍵}10 25 50
          sizes←sizes,(rows≠¯1↑sizes)/rows
          sizes←sizes,[1.1](¯1↓sizes),⊂'All'
          :With #.HTMLInput
              html←Tag'img src="/Styles/pager/first.png" class="first"'
              html,←Tag'img src="/Styles/pager/prev.png" class="prev"'
              html,←Tag'input type="text" readonly="readonly" class="pagedisplay"'
              html,←Tag'img src="/Styles/pager/next.png" class="next"'
              html,←Tag'img src="/Styles/pager/last.png" class="last"'
              html,←DropDown sizes(⍬⍴sizes)'class="pagesize"'
              r,←'div id="pager" class="pager"'Enclose'form'Enclose html
              jqpars,←(0∊⍴jqpars)↓',widthFixed:true'
          :EndWith
      :EndIf
      r,←JQueryfn'tablesorter'id jqpars(pager/'.tablesorterPager({container: $("#pager")})')
    ∇

    ∇ r←{req}Accordion(id hdrs content jqpars)
    ⍝ req - HTTPRequest object
    ⍝ id - the id for the accordion
    ⍝ jqpars - Accordion parameters
    ⍝ hdrs - n-element array of header names for each accordion folder
    ⍝ content - n-element array of content for each accordion folder
    ⍝ updates req.Response.head and returns html
      :If 9=⎕NC'req' ⋄ IncludeJQueryUI req ⋄ :EndIf
      hdrs←#.HTML.h3¨('href' '#')∘#.HTML.a¨hdrs
      content←#.HTML.div¨content
      r←'id'id #.HTML.div,hdrs,[1.1]content
      r,←JQueryfn'accordion'id jqpars
    ∇

    ∇ r←{req}Tabs(id tabnames content jqpars);tabids
    ⍝ req - HTTPRequest object
    ⍝ id - the id for the tabs
    ⍝ jqpars - Tabs parameters
    ⍝ content - nx2 matrix of [;1] tab titles [;2] tab contents
    ⍝ updates req.Response.head and returns html
      tabnames←eis tabnames
      content←eis content
      :If 9=⎕NC'req' ⋄ IncludeJQueryUI req ⋄ :EndIf
      tabids←id∘,¨('-'∘,¨⍕¨⍳⍴tabnames),¨'"'
      r←'ul'#.HTMLInput.Enclose enlist'li'∘#.HTMLInput.Enclose¨('a href="#'∘,¨tabids)#.HTMLInput.Enclose¨tabnames
      r,←enlist('div id="'∘,¨tabids)#.HTMLInput.Enclose¨content
      r←'id'id #.HTML.div r
      r,←JQueryfn'tabs'id jqpars
    ∇

    ∇ r←{req}Dialog(id title innerhtml jqpars)
    ⍝ req - HTTPRequest object
    ⍝ id - the id for the dialog
    ⍝ jqpars - Dialog parameters
    ⍝ title - title for the dialog
    ⍝ innerhtml - body for the dialog
    ⍝ updates req.Response.head and returns html
      :If 9=⎕NC'req' ⋄ IncludeJQueryUI req ⋄ :EndIf
      r←'title'title #.HTML.div innerhtml
      r,←JQueryfn'dialog'id jqpars
    ∇

    ∇ r←{req}Sortable pars;ids;lists;styles;usehd;jqpars;chain;liststyle;itemstyle;style;js
      pars←eis pars
      :If 9=⎕NC'req' ⋄ IncludeJQueryUI req ⋄ :EndIf
      usehd ids lists styles jqpars chain←6↑pars,(⍴pars)↓0 '' '' '' '' ''
      :If 0∊⍴styles ⋄ liststyle←itemstyle←''
      :Else ⋄ listsytle itemstyle←styles
      :EndIf
      liststyle←liststyle,⍨'list-style-type' 'none' 'margin' 0 'padding' 0 'float' 'left' 'margin-right' '10px' 'background' '#eee' 'padding' '5px' 'width' '143px'
      itemstyle←itemstyle,⍨'margin' '5px' 'padding' '5px' 'font-size' '1.2em' 'width' '120px'
      ids←eis ids
      style←⊂('#'∘,¨ids)#.HTMLInput.MakeStyle liststyle
      style,←⊂('#'∘,¨ids,¨⊂' li')#.HTMLInput.MakeStyle itemstyle
      style←'style'#.HTMLInput.Enclose style
      lists←eis¨lists
      lists←'li class="ui-state-default"'∘#.HTMLInput.Enclose¨¨lists
      :If usehd
          lists←{w←⍵ ⋄ f←'ui-state-disabled'insertClass 1⊃w ⋄ w[1]←⊂f ⋄ w}¨lists
      :EndIf
      lists←(1∘⌽¨'"ul id="'∘,¨ids)#.HTMLInput.Enclose¨lists
      jqpars←2↓enlist', '∘,¨(⊂'')~⍨((1<⍴lists)/'connectWith: "ul"')(usehd/'items: "li:not(.ui-state-disabled)"')jqpars
      chain←'.disableSelection()',chain
      js←JQueryfn'sortable'ids jqpars chain
      r←style,(enlist CRLF∘,¨lists),CRLF,js,'div style="clear: both;"' #.HTMLInput.Enclose ''
    ∇

:EndNamespace