﻿:namespace Summary

    ⎕ml←3 ⋄ ⎕io←1
    Cmds←'Summary' 'FnCalls' 'Xref'  'cd'  'display' 'disp' 'toHex' 'fromHex' 'factorsof' 'ftttots'

    ∇ r←List;i
      :Access Shared Public
      r←⎕NS¨(⍴Cmds)⍴⊂''
      r.Group←⊂'Tools'
      r.Parse←'1L -file' '2LS -details -treeview -file -full' '1L -file' '' '' '' '' '' '' ''
      r.Name←Cmds
      i←0 ⍝ i←i+1 allows inserting new cmds w/o renumbering
      r[i←i+1].Desc←'Returns a summary of the objects in a namespace or scriptfile'
      r[i←i+1].Desc←'Returns the calling tree of a function in a namespace or scriptfile'
      r[i←i+1].Desc←'Returns a Cross-reference of the objects in a namespace or scriptfile'
      r[i←i+1].Desc←'Change or report the current working directory'
      r[i←i+1].Desc←'DISPLAY expression'
      r[i←i+1].Desc←'disp expression'
      r[i←i+1].Desc←'Show HEXADECIMAL representation of a number(s)'
      r[i←i+1].Desc←'Show DECIMAL representation of an HEX number(s)'
      r[i←i+1].Desc←'Show the factors of a number'
      r[i←i+1].Desc←'Show the ⎕TS equivalent of a component timestamp'
    ∇

    ∇ r←Run(Cmd Args);ct;ns;sw;sp;file;arg;tmpNS;icmd;WIN;fn
      :Access Shared Public
      :If 4>icmd←Cmds⍳⊂Cmd
          fn←file←1⊃ct←Args.Arguments
          :If icmd=2
              :If 1=⍴ct ⋄ file←'⎕this'
              :Else ⋄ file←2⊃ct
              :EndIf
          :EndIf
          :If ~Args.file         ⍝ get the space
              tmpNS←##.THIS⍎file
          :Else
              r ⎕SIGNAL 11⌊⍴r←tmpNS←⎕SE.SALT.Load'"',file,'" -noname'
          :EndIf
          ct←⎕SE.SALT.New'Tools\DanB\callingTree'tmpNS
      :EndIf
      :Select icmd ⍝ use numbers so we can rename cmds at will
      :Case 1
          r←format ct.FnRefs
      :Case 2
          r←ct.Calls(⊂fn),Args.(treeview details 999 full)
      :Case 3
          r←ct.Xref
      :Case 4
          WIN←⍬⍴'Windows'⍷1⊃'.'⎕WG'APLVersion'
          'Unix version not available'⎕SIGNAL 11⍴⍨WIN<' '∨.≠Args
          :If WIN ⋄ r←CD{(+/∧\' '=⍵)↓⍵}Args
          :Else ⋄ r←⎕SH'pwd'
          :EndIf
      :Case 5
          r←DISPLAY ##.THIS⍎Args
      :Case 6
          r←disp ##.THIS⍎Args
      :Case 7
          r←0 hex Args
      :Case 8
          r←1 hex Args
      :Case 9
          r←factorsOf ##.THIS⍎Args
      :Case 10
          r←dywftt ##.THIS⍎Args
      :EndSelect
    ∇

    ∇ r←bw hex num;HEX;⎕IO;⎕ML
     ⍝ Turn a number into HEX format or the other way around if la is 1
     ⍝ or if number starts with a 0 or contains an Hex digit
      →(num∨.≠' ')↓⍴r←⍬
      ⎕ML←⎕IO←0 ⋄ HEX←⎕D,'ABCDEFabcdef'
      'invalid number(s)'⎕SIGNAL 11↓⍨∧/(⍕num)∊' ',(¯12×0=bw)↓HEX
      num←(⊂'')~⍨{1↓¨(⍵∊' ')⊂⍵}' ',num ⍝ cut on spaces
      :If bw
          r←16⊥¨{⍵-6×⍵>15}¨HEX∘⍳¨num
      :Else
          r←{HEX[16⊥⍣¯1⍎⍵]}¨num
      :EndIf
    ∇

      DISPLAY←{⎕IO ⎕ML←0                              ⍝ Boxed display of array.
          ⍺←1 ⋄ chars←⍺⊃'..''''|-' '┌┐└┘│─'           ⍝ ⍺: 0-clunky, 1-smooth.
          tl tr bl br vt hz←chars                     ⍝ Top left, top right, ...
          box←{                                       ⍝ Box with type and axes.
              vrt hrz←(¯1+⍴⍵)⍴¨vt hz                  ⍝ Vert. and horiz. lines.
              top←(hz,'⊖→')[¯1↑⍺],hrz                 ⍝ Upper border with axis.
              bot←(⊃⍺),hrz                            ⍝ Lower border with type.
              rgt←tr,vt,vrt,br                        ⍝ Right side with corners.
              lax←(vt,'⌽↓')[¯1↓1↓⍺],¨⊂vrt             ⍝ Left side(s) with axes,
              lft←⍉tl,(↑lax),bl                       ⍝ ... and corners.
              lft,(top⍪⍵⍪bot),rgt                     ⍝ Fully boxed array.
          }
          deco←{⍺←type open ⍵ ⋄ ⍺,axes ⍵}             ⍝ Type and axes vector.
          axes←{(-2⌈⍴⍴⍵)↑1+×⍴⍵}                       ⍝ Array axis types.
          open←{(1⌈⍴⍵)⍴⍵}                             ⍝ Expose null axes.
          trim←{(~1 1⍷∧⌿⍵=' ')/⍵}                     ⍝ Remove extra blank cols.
          type←{{(1=⍴⍵)⊃'+'⍵}∪,char¨⍵}                ⍝ Simple array type.
          char←{⍬≡⍴⍵:hz ⋄ (⊃⍵∊'¯',⎕D)⊃'#~'}∘⍕         ⍝ Simple scalar type.
          {                                           ⍝ Recursively box arrays:
              0=≡⍵:' '⍪(open ⎕FMT ⍵)⍪(⊃⍵ ⍵∊⎕AV)⊃' -'  ⍝ Simple scalar.
              1 ⍬≡(≡⍵)(⍴⍵):'∇' 0 0 box ⎕FMT ⍵         ⍝ Object rep: ⎕OR.
              1=≡⍵:(deco ⍵)box open ⎕FMT open ⍵       ⍝ Simple array.
              ('∊'deco ⍵)box trim ⎕FMT ∇¨open ⍵       ⍝ Nested array.
          }⍵
      }

      disp←{⎕IO ⎕ML←0                             ⍝ Boxed sketch of nested array.
     
          ⍺←⍬ ⋄ opt ldr ctd←3↑⍺,3/1               ⍝ ⍺: decorated, box_chars, centred.
     
          ul uc ur←ldr⊃⌽'┌┬┐' '.'                 ⍝ upper──┐ ┌───left
          ml mc mr←ldr⊃⌽'├┼┤' '|+|'               ⍝ middle─┼×┼─centre
          ll lc lr←ldr⊃⌽'└┴┘' ''''                ⍝ lower──┘ └──right
          vt hz←ldr⊃'|-' '│─'                     ⍝ vertical and horizontal.
     
          box←{                                   ⍝ Recursively box nested array.
              isor ⍵:⎕FMT⊂⍵                       ⍝ ⎕or: '∇name'.
              1≥|≡⍵:open ⎕FMT open ⍵              ⍝ simple array: format.
              subs←expand ∇¨matr open ⍵           ⍝ expanded boxed sub-arrays.
              odec←(shape ⍵)outer subs            ⍝ outer type and shape decoration.
              idec←inner ⍵                        ⍝ inner type and shape decorations.
              (odec,idec)collect subs             ⍝ collected, formatted sub-arrays.
          }
     
          expand←{                                ⍝ Align and centre sub-arrays.
              rows cols←sepr⍴¨⍵                   ⍝ sub-array dimensions.
              sizes←(⌈/rows)∘.,⌈⌿cols             ⍝ expanded sub-array sizes.
              ctd=0:sizes↑¨⍵                      ⍝ top-left alignment.
              v h←sepr⌈0.5×↑(⍴¨⍵)-sizes           ⍝ vertical and horizontal rotation.
              v⊖¨h⌽¨sizes↑¨⍵                      ⍝ centred expanded sub-arrays.
          }
     
          outer←{                                 ⍝ Outer decoration.
              on←{⍺:⍺⍺ ⍵ ⋄ ⍵}                     ⍝ conditional function application.
              sizes←1 0{⊃↓⍺⍉on ⍵}¨sepr⍴¨⍵         ⍝ row and col sizes of sub-arrays.
              sides←sizes/¨¨vt hz                 ⍝ vert and horiz cell sides.
              bords←1↓¨ml uc glue¨sides           ⍝ joined up outer borders.
              ↑,¨/(ul'')⍺ bords(ll ur)            ⍝ vertical and horizontal borders.
          }
     
          inner←{                                 ⍝ Inner sub-array decorations.
              deco←{(type ⍵),shape ⍵}             ⍝ type and shape decorators.
              sepr deco¨matr open ⍵               ⍝ decorators: tt vv hh .
          }
     
          collect←{                               ⍝ Collect sub-arrays.
              lft top tt vv hh←⍺                  ⍝ array and sub-array decorations.
              boxes←vv right(tt hh)lower ⍵        ⍝ cells boxed right and below.
              lft,top⍪↑⍪⌿,/open boxes             ⍝ completed collection.
          }
     
          lower←{                                 ⍝ Border below each sub-array.
              bot←{⍵⍪(-1⊃⍴⍵)↑⍺ split ⍵}           ⍝ lower border.
              split←{((¯2+1⊃⍴⍵)/hz)glue ⍺}        ⍝ decorators split with horiz line.
              (matr↑,¨/⍺)bot¨matr ⍵               ⍝ cells bordered below.
          }
     
          right←{                                 ⍝ Border right each sub-array.
              types←2⊥¨(⍳⍴⍵)=⊂¯1+⍴⍵               ⍝ right border lower corner types.
              chars←mc mr lc lr[types]            ⍝    ..     ..      ..      chars.
              rgt←{⍵,(¯2+⊃⍴⍵)1 1/vt,⍺}            ⍝ form right border.
              ((matr ⍺),¨chars)rgt¨⍵              ⍝ cells bordered right.
          }
     
          type←{                                  ⍝ Type decoration char.
              opt<|≡⍵:hz                          ⍝ nested: '─'
              isor ⍵:'∇'                          ⍝ ⎕or:    '∇'
              sst←{                               ⍝ simple scalar type.
                  0=opt×⍴⍴⍵:hz                    ⍝ undecorated or scalar ⍕⍵: char,
                  (⊃⍵∊'¯',⎕D)⊃'#~'                ⍝ otherwise, number or space ref.
              }∘⍕                                 ⍝ ⍕ distinguishes type of scalar.
              0=≡⍵:sst ⍵                          ⍝ simple scalar: type.
              {(1=⍴⍵)⊃'+'⍵}∪,sst¨open ⍵           ⍝ array: mixed or uniform type.
          }
     
          shape←{                                 ⍝ Row and column shape decorators.
              0=opt×⍴⍴⍵:vt hz                     ⍝ scalar or no decoration.
              cols←(×¯1↑⍴⍵)⊃'⊖→'                  ⍝ zero or more cols.
              rsig←(××/¯1↓⍴⍵)⊃'⌽↓'                ⍝ zero or more rows.
              rows←(¯1+3⌊⍴⍴⍵)⊃vt rsig'⍒'          ⍝ high rank decorator overrides.
              rows cols                           ⍝ shape decorators.
          }
     
          matr←{↑,↓⍵}                             ⍝ Matrix from non-scalar array.
          sepr←{+/¨1⊂↑⍵}                          ⍝ Vec-of-mats from mat-of-vecs.
          open←{16::(1⌈⍴⍵)⍴⊂'[ref]' ⋄ (1⌈⍴⍵)⍴⍵}   ⍝ Stretch to expose nulls.
          isor←{1 ⍬≡(≡⍵)(⍴⍵)}                     ⍝ Is ⎕or of object?
          glue←{↑⍺{⍺,⍺⍺,⍵}/⍵}                     ⍝ Intersperse ⍵ with ⍺s.
     
          box ⍵                                   ⍝ recursively box array.
      }

    ∇ {old}←CD new;get;set;size;t                         ⍝ Change directory.
     ⍝ Change Directory under DOS
      t←'A*'[1+80=⎕DR'']
      'get'⎕NA'U Kernel32|GetCurrentDirectory',t,' U >0T' ⍝ Associate Get function.
      'set'⎕NA'U Kernel32|SetCurrentDirectory',t,' <0T'   ⍝     "     Set    "
      (size old)←get 260 260                              ⍝ Get current directory.
      :If ×⍴,new                                          ⍝ If target directory.
          ⎕SIGNAL(set⊂new)↓11                             ⍝ Domain error if fails.
      :End                                                ⍝ Old dir is shy rslt.
    ∇

      factorsOf←{⎕ML ⎕IO←1        ⍝ Prime factors of ⍵.
          ⍵{                      ⍝ note: ⎕wa>(⍵*÷2)×2*4.
              ⍵,(⍺÷×/⍵)~1         ⍝ append factor > sqrt(⍵).
          }∊⍵{                    ⍝ concatenated,
              (0=(⍵*⍳⌊⍵⍟⍺)|⍺)/⍵   ⍝ powers of each prime factor.
          }¨⍬{                    ⍝ remove multiples:
              nxt←⊃⍵              ⍝ next prime, and
              msk←0≠nxt|⍵         ⍝ ... mask of non-multiples.
              ∧/1↓msk:⍺,⍵         ⍝ all non multiples - finished.
              (⍺,nxt)∇ msk/⍵      ⍝ sieve remainder.
          }⍵{                     ⍝ from,
              (0=⍵|⍺)/⍵           ⍝ divisors of ⍵ in:
          }2,(1+2×⍳⌊0.5×⍵*÷2),⍵   ⍝ 2,3 5 .. sqrt(⍵),⍵
      }

⍝ Produce a summary of a class' (in a .Dyalog file) objects.

    ∇ r←format m3c;ss;t3
    ⍝ Format function references
    ⍝ 3rd column contains scope, size & syntax as per ⎕AT
      r←'No functions found' ⋄ →0/⍨0∊⍴m3c
      t3←⊃,0 1↓ss←0 1↓⊃m3c[;3] ⋄ ss[;2]←t3[;1] ⋄ t3←↓1+|0 1↓t3
      t3←t3⌷¨⊂⊃∘.,/'nr' '012' 'fmd'
      r←⍕'name' 'scope' 'size' 'syntax'⍪m3c[;1],ss,t3
    ∇

    ∇ ts←dywftt ts;md;shape;tmp;yr;z;⎕IO
    ⍝ *** convert ⎕FRDCI timestamp(s) to ⎕ts-format for Dyalog/W ***
    ⍝ right argument: ⎕FRDCI-type timestamp(s) of any shape
    ⍝ result: ⎕ts-type timestamp(s) with shape <(⍴argument),7>
      ⎕IO←0 ⋄ shape←⍴ts ⋄ ts←,ts+18626112000
      md←365.2501|1+1461|yr←⌊ts÷5184000
      tmp←31 61 92 122 153 184 214 245 275 306 337 366
      z←(,⍉<⍀tmp∘.≥md)/,((⍴md),12)⍴⍳12
      md←(1+12|z+2),[0.1]⌈md-(0,tmp)[z]
      ts←(1960+⌊(yr+60)÷365.25),md,⍉24 60 60 60⊤ts
      ts[;6]←⌊0.5+ts[;6]×100÷6
      ts←(shape,7)⍴ts
    ∇

    ∇ r←lev Help Cmd;i;F
      :Access Shared Public
      F←'' 'The switch  -file  will interpret the argument to be a filename'
      :Select Cmds⍳⊂Cmd
      :Case 1 ⍝ Summary
          i←,⊂r←'Arg: scriptfile; Produces a short description of the functions in a class'  ⍝ summary
          →lev↓0
          i,←'' 'For a given class all regular fns & dfns are reported,'
          i,←⊂'listing their syntax and scope.'
          i,←⊂'Syntax is [nr][012][mdf] where'
          i,←⊂'n is no result, r is result'
          i,←⊂'0 is niladic, 1 monadic and 2 dyadic,'
          i,←⊂'m is a Monadic operator, d a Dyadic op and F a Function'
          i,←'' 'Ex: r0f is a result returning niladic fn'
          i,←⊂'Scope is [SPCD] where'
          i,←⊂'S is shared, P is public, C is constructor and D is destructor'
          r←⊃i,F
      :Case 2     ⍝ fncalls
          i←⊂r←'Arg: scriptfile function; Produces the calling tree of a fn (arg 1) in a class (arg 2, default current ns)'
          →lev↓0
          i,←F
          i,←⊂'-details shows other references (ex: vars)'
          i,←' Each name is preceded by a symbol. Its meaning is' ''
          i,←⊂'  G global object (not a visible function)'
          i,←⊂'  F visible function'
          i,←⊂'  R recursive function call'
          i,←⊂'  * function already shown (only without FULL option)'
          i,←⊂'  ○ local  object'
          i,←⊂'  ! unreferenced local object'
          i,←⊂'  l unreferenced label'
          i,←⊂'  L referenced label'
          i,←'  ↑ global local (global localized at an upper level)' ''
          i,←⊂'-treeview uses GUI to show the result'
          i,←⊂'-full repeats description of already shown fns'
          i,←'' 'NOTE: the only function names reported are in the same namespace.'
          r←⊃i
     
      :Case 3
          i←⊂r←'Arg: namespace name; Produces a cross-reference of all objects in a class'  ⍝ xref
          →lev↓0
          i,←F
          r←⊃i
     
      :Case 4
          i←⊂r←'Arg: new directory. Changes the current directory to the one specified or display the current if none supplied' ⍝ cd                                                                      ⍝ cd
          →lev↓0
     
      :Case 5
          i←⊂r←'Arg: any array. Shows the array as per DISPLAY'      ⍝ display
          →lev↓0
     
      :Case 6
          i←⊂r←'Arg: any array. Shows the array as per the <disp> fn' ⍝ disp
          →lev↓0
     
      :Case 7
          i←⊂r←'Arg: numbers in decimal. Shows their HEX equivalent' ⍝ tohex
          →lev↓0
     
      :Case 8
          i←⊂r←'Arg: numbers in HEX. Shows their decimal equivalent' ⍝ fromhex
          →lev↓0
     
      :Case 9
          i←⊂r←'Arg: a single integer. Its factors are returned'     ⍝ factorsof
          →lev↓0
     
      :Case 10
          i←⊂r←'Arg: a single float number. Its ⎕TS equivalent is returned'     ⍝ ftttots
          →lev↓0
     
      :EndSelect
    ∇

⍝ Spice example:
⍝ fncalls  utils\callingTree ctor -details -treeview

:Endnamespace